using System;
using System.Collections;
using System.Collections.Generic;
using BITKit.StateMachine;
using Cysharp.Threading.Tasks;

namespace Net.Project.B.PDA
{
    public interface IApp
    {
        public string PackageName { get; }
        public string AppName { get; }
    }

    public interface IAppClass:IStateAsync
    {
        public Type AppType { get; }
        public IReadOnlyList<string> Routes { get; }
        public UniTask<object> GetPage(string route);
    }

    public interface IAppClass<T> : IAppClass
    {
        
    }
}

namespace Net.Project.B.PDA.App
{
    [Serializable]
    public struct Phone:IApp
    {
        public string PackageName => "com.bndroid.phone";
        public string AppName => "拨号";
    }
    [Serializable]
    public struct Map:IApp
    {
        public string PackageName => "com.bndroid.map";
        public string AppName => "地图";
    }
    [Serializable]
    public struct Quest:IApp
    {
        public string PackageName => "com.bndroid.quest";
        public string AppName => "任务";
    }
}
