using System;
using System.Collections;
using System.Collections.Generic;
using BITKit.WorldNode;
using Net.Project.B.Interaction;
#if UNITY_5_3_OR_NEWER
using UnityEngine;
#endif

namespace Net.Project.B.WorldNode
{
    public enum UnityDoorState
    {
        NoState,
        Opened,
        Closed,
        Disabled,
        Locked,
    }
    [Serializable]
    public class UnityDoorNode:IWorldNode
    {
        public int Id { get; set; }
        public UnityDoorState State;
        public WorldInteractionProcess InteractionType;
        public bool IsDoubleSwing;
#if UNITY_5_3_OR_NEWER
        public Transform DoorTransform;
        public Vector3 OpenPosition;
        public Vector3 ClosePosition;
        public Vector3 OpenEulerAngles;
        public Vector3 CloseEulerAngles;
#endif
    }
}
