using System;
using System.Collections;
using System.Collections.Generic;
using BITKit;
using BITKit.WorldNode;
#if UNITY_5_3_OR_NEWER
using UnityEngine;
#endif

namespace Net.Project.B.WorldNode.Loot
{
    [Serializable]
    public struct CommonLootNode : IReference
    {
        public string Get() => "loot_common";
    }

    [Serializable]
    public struct MedicalLootNode : IReference
    {
        public string Get() => "loot_medical";
    }

    [Serializable]
    public struct MilitaryLootNode : IReference
    {
        public string Get() => "loot_military";
    }

    [Serializable]
    public struct FoodLootNode : IReference
    {
        public string Get() => "loot_food";
    }

    [Serializable]
    public struct BeverageLootNode : IReference
    {
        public string Get() => "loot_beverage";
    }

    [Serializable]
    public struct HouseholdToolsLootNode : IReference
    {
        public string Get() => "loot_household_tools";
    }

    [Serializable]
    public struct HardwareToolsLootNode : IReference
    {
        public string Get() => "loot_hardware_tools";
    }

    [Serializable]
    public struct SurvivalGearLootNode : IReference
    {
        public string Get() => "loot_survival_gear";
    }

    [Serializable]
    public struct ConstructionLootNode : IReference
    {
        public string Get() => "loot_construction";
    }

    [Serializable]
    public struct ClothingLootNode : IReference
    {
        public string Get() => "loot_clothing";
    }

    [Serializable]
    public struct ElectronicsLootNode : IReference
    {
        public string Get() => "loot_electronics";
    }

    [Serializable]
    public struct FuelLootNode : IReference
    {
        public string Get() => "loot_fuel";
    }

    [Serializable]
    public struct MeleeWeaponLootNode : IReference
    {
        public string Get() => "loot_melee_weapon";
    }

    [Serializable]
    public struct RangedWeaponLootNode : IReference
    {
        public string Get() => "loot_ranged_weapon";
    }

    [Serializable]
    public struct ThrowableLootNode : IReference
    {
        public string Get() => "loot_throwable";
    }

    [Serializable]
    public struct TrapLootNode : IReference
    {
        public string Get() => "loot_trap";
    }

    [Serializable]
    public struct QuestItemLootNode : IReference
    {
        public string Get() => "loot_quest_item";
    }

    [Serializable]
    public struct TradeGoodsLootNode : IReference
    {
        public string Get() => "loot_trade_goods";
    }

    [Serializable]
    public struct AnimalProductLootNode : IReference
    {
        public string Get() => "loot_animal_product";
    }
}

namespace Net.Project.B.WorldNode
    {
    [Serializable]
    public class UnityLootNode : IWorldNode
    {
#if UNITY_5_3_OR_NEWER
        [SerializeReference, SubclassSelector] public IReference lootName;

        public string LootName => lootName?.Value;
#endif
    }
}
